博客
关于我
强烈建议你试试无所不能的chatGPT,快点击我
CodeChef - METEORAK Meteor
阅读量:5103 次
发布时间:2019-06-13

本文共 2922 字,大约阅读时间需要 9 分钟。

Read problems statements in and .

A meteor fell on Andrew's house. That's why he decided to build a new home and chose a site where he wanted to build it. Let the whole area be a rectangular field of size NxM. Naturally, Andrew wanted to build a house on the entire area of the site. However, the Hazardous Construction Prevention Bureau did not let Andrew's plans come true. The Bureau said that some of the cells of the field are dangerous for the foundation. There are exactly K such cells.

Andrew's not a poor man. And as anyone who has money, he saves money. Therefore, he is willing to buy not the whole area, but only a stripe of the same width. The house will occupy a rectangular area in this stripe with sides parallel to the sides of the original site.

Andrew is asking for your help: for each LiHi - the lowest and the highest boundaries (inclusive), respectively - find the maximum area of ​​the house that Andrew can build on the relevant site.

 

Input

In the first line you are given three integers NM and K.

In the following K lines you are given different pairs of integers xiyi - the coordinates of the dangerous cells.
Next line contains an integer Q - the number of Andrew's queries
The last Q lines describe the queries: each line contains two integers L and H - the lowest and the highest boundaries.

 

Output

In the output file, print Q lines, where i-th line contains the answer for i-th query. If you cannot build the house, then output 0.

 

Constraints

  • 1 ≤ N, M ≤ 1000
  • 1 ≤ K ≤ N * M
  • 1 ≤ xi ≤ N
  • 1 ≤ yi ≤ M
  • 1 ≤ Q ≤ 106
  • 1 ≤ Li ≤ Hi ≤ N

 

Example

Input:4 5 52 13 21 32 41 441 13 42 31 4Output:2636     发现询问数过于多了,因为最多的行区间不过10^6,所以我们可以先预处理出所有区间的答案然后O(1)回答询问。     设f[i][j] 为第i~j行的最大矩阵面积,也就是题目所求。然后再设g[i][j]为 上边界是i,下边界是j的矩阵最宽可以是多少。 于是转移很好写 => f[i][j] = max{f[i+1][j] , f[i][j-1] , g[i][j] * (j-i+1)}.所以现在关键是怎么求 g[i][j]。     考虑单调栈求一个二维最大全1矩形的做法,我们可以扩展一下: 加入当前扫到的下边界在i,然后对于从左到右的每一个点j,它向上的高度是h[j],并且 向左右最多能延伸的位置是 L[j],R[j],这个时候我们就可以用 R[j]-L[j]+1去更新 g[i-h[j]+1 ~ i][i]。     当然不能暴力更新,打个标记之后就是O(N^2)的了,,再加上算f也是O(N^2)的,就可以愉快的A了本题了23333
#include
#define ll long longusing namespace std;const int maxn=1005;int F[maxn][maxn],G[maxn][maxn];int n,m,Q,PX,PY,num,s[maxn],tp;int L[maxn],R[maxn],h[maxn];bool v[maxn][maxn];inline int read(){ int x=0; char ch=getchar(); for(;!isdigit(ch);ch=getchar()); for(;isdigit(ch);ch=getchar()) x=x*10+ch-'0'; return x;}inline void init(){ for(int i=1;i<=n;i++){ for(int j=1;j<=m;j++) if(v[i][j]) h[j]=0; else h[j]++; s[tp=0]=0; for(int j=1;j<=m;j++){ while(tp&&h[s[tp]]>=h[j]) tp--; L[j]=s[tp],s[++tp]=j; } s[tp=0]=m+1; for(int j=m;j;j--){ while(tp&&h[s[tp]]>=h[j]) tp--; R[j]=s[tp],s[++tp]=j; } for(int j=1;j<=m;j++) G[i][i-h[j]+1]=max(G[i][i-h[j]+1],R[j]-L[j]-1); for(int j=1;j<=i;j++) G[i][j]=max(G[i][j],G[i][j-1]); } for(int i=1;i<=n;i++) F[i][i]=G[i][i]; for(int len=1;len

  

 

转载于:https://www.cnblogs.com/JYYHH/p/8849148.html

你可能感兴趣的文章
HTML5新API记录
查看>>
Android 8 AudioPolicy 分析
查看>>
自收藏的 小技巧
查看>>
Knight Moves
查看>>
hdu 1080 (DP LCS最长公共子序列)
查看>>
在NodeJS中使用Redis缓存数据
查看>>
实验8:数组2
查看>>
JavaScript案例一:Window弹窗案例
查看>>
当Ext.js中xtype: 'checkboxfield'时,没勾选则向后台发送的数据没有字段的解决方法...
查看>>
转载 《TypeScript 类型定义 DefinitelyTyped》
查看>>
Latent Dirichlet Allocation(LDA)
查看>>
hihocoder 1388 Periodic Signal
查看>>
MYSQL 开发技巧
查看>>
服务端的流水线
查看>>
ELK架构浅析
查看>>
UI4_UIWebView
查看>>
并查集
查看>>
centos从安装到环境配置
查看>>
只让类访问, 而不让类的实例来访问某个成员变量
查看>>
Python学习笔记第二十四周(JavaScript补充)
查看>>